;Keil 5

dataptr   set r0	;data to scan
Length set r1    
Highest 	equ 20h

; test data
byte1 equ 0x71
byte2 equ 0x72
byte3 equ 0x73
byte4 equ 0x74
byte5 equ 0x75
	
	

org 0    ;place code at start of rom
	jmp start  ;standard jump over irq vectors..not really needed, but good practise


org 0x40   ;place code after irq vectors...not really needed, but good practise
start:

;setup test values
mov byte1,#7
mov byte2,#79
mov byte3,#100
mov byte4,#22
mov byte5,#90

;set up pointers etc

mov dataptr,#0x71 ;start of the sequence
mov Length ,#5    ;length of sequence
mov Highest,#0

again:
       mov A,@dataptr  ;byte to test	   
       cjne A,Highest,$+3     ;compare with highest so far. carry set if  A is lss than Highest
		                    ;$+3 is a 'trick'. We still end up at "jc continue"
	   jc continue
	   mov Highest,A     ;new highest or equal value
continue:	   
		inc   dataptr    ;next byte
		djnz Length,again

;exit loop
         mov A,Highest
         jmp $ ;'trick' to stop program
			 
			 
  END